﻿using Luticate2.Utils.Dbo.Basic;
using Luticate2.Utils.Interfaces;

namespace Luticate2.Utils.Business
{
    public static class LuUtilsBusinessExtensions
    {
        public static void NotifyCreate(this ILuNotificationsBusiness business, string entityType, object newEntity)
        {
            business.Notify(LuUtilsConstants.EventCreate, entityType, null, newEntity);
        }

        public static void NotifyUpdate(this ILuNotificationsBusiness business, string entityType, object oldEntity, object newEntity)
        {
            business.Notify(LuUtilsConstants.EventUpdate, entityType, oldEntity, newEntity);
        }

        public static void NotifyDelete(this ILuNotificationsBusiness business, string entityType, object oldEntity)
        {
            business.Notify(LuUtilsConstants.EventDelete, entityType, oldEntity, null);
        }
    }
}